﻿// Copyright 2012-2013 Dmitry Kischenko
//
// Licensed under the Apache License, Version 2.0 (the "License"); 
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software 
// distributed under the License is distributed on an "AS IS" BASIS, 
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either 
// express or implied. 
// See the License for the specific language governing permissions and 
// limitations under the License.
using System;

namespace xFunc.Maths
{
    
    /// <summary>
    /// Numeral systems.
    /// </summary>
    public enum NumeralSystem
    {

        /// <summary>
        /// The binary numeral system.
        /// </summary>
        Binary      = 2,
        /// <summary>
        /// The octal numeral system.
        /// </summary>
        Octal       = 8,
        /// <summary>
        /// The decimal numeral system.
        /// </summary>
        Decimal     = 10,
        /// <summary>
        /// The hexidecimal numeral system.
        /// </summary>
        Hexidecimal = 16

    }

}
